//////////////////////////////
//    Dynamic-AI-Creator    //
//    Version 2.0 - 2007    //
//--------------------------//
//    DAC_Move_Random       //
//--------------------------//
//    Script by Silola      //
//    silola@mapfact.net    //
//////////////////////////////

private [
			"_garray","_group","_marker","_wparray","_groupid","_heloarray","_vehcargo","_leader","_helo","_EventList",
			"_exgroup","_nextpos","_target","_zonepos","_knowsabout","_landmodus","_maxwps","_hcrew","_rd","_flypos","_rdir",
			"_driver","_gunner","_zskill","_DAC_Arrays","_wait","_run","_go","_crew","_man","_dist","_jArray","_grouponfire",
			"_unitwait1","_unitwait2","_patrolon","_unitcombat","_unitbehav","_unitspeed","_unitheight","_maxweather","_oldskill",
			"_patrolX","_patrolY","_ActivZoneX","_ActivZoneY","_RandomX","_RandomY","_NewHeight","_movepos","_eventid","_newtarget",
			"_speedselect","_combatselect","_behavselect","_homepos","_callg","_call","_hport","_helip","_temppos","_sum","_inflight"
		];

			_garray = _this select 0;_group = _garray select 0;_marker = _garray select 1;_wparray = _this select 1;_groupid = _this select 2; 
			_heloarray = _this select 3;_vehcargo = _this select 4;_leader = leader _group;_helo = _this select 5;_exgroup = _group;_call = [];
			_movepos = position _leader;_nextpos = "logic" createvehiclelocal [0,0,0];_target = objNull;_zonepos = [];_eventid = _garray select 2;
			_knowsabout = ((DAC_KnowsAbout + 2) - ((skill _leader * 2) + 0.01));_temppos = position _leader;_landmodus = 0;_maxwps = 0;
			_group lockWP true;_hcrew = crew _helo;_driver = driver _helo;_gunner = objNull;_crew = [];_man = _leader;_jArray = [];
			_zskill = [((getMarkerPos (_marker select 2)) select 1)] call DAC_fConfigBehav;_run = 1;_go = 1;_wait = 1;_unitwait1 = 0;
			_oldskill = ((getMarkerPos (_marker select 2)) select 1);_dist = 0;_unitwait2 = 0;_rdir = 0;_EventList = [];_newtarget = objNull;
			_DAC_Arrays = ["DAC_Help_Groups","DAC_Hit_Groups","DAC_Fire_Groups","DAC_Radio_Groups","DAC_Cover_Groups","DAC_Call_Groups"];
			_rd = 0;_callg = [];_helip = objNull;_sum = 0;_grouponfire = _group;_flypos = [0,0,0];_inflight = 0;
			if(count _hcrew > 1) then {_gunner = gunner _helo};

while {_run > 0} do
{
	switch (_run) do
	{
		case 1:	{
					//-----------------------------
					//#start
					//-----------------------------
					if(_vehcargo == 1) then
					{
						[_group, 2] setWaypointPosition [[30,0], 0];
						waituntil {((count crew _helo) > (count units _group))};
						sleep 0.1;
						{if(!(group _x == _group)) then {_exgroup = group _x}} foreach crew _helo;
					};
					[_group, 1] setWaypointPosition [[10,0], 0];
					sleep 3;
					waituntil {((getdir DAC_StartDummy) > 170)};
					if(_eventid > 0) then {_EventList = ((([_eventid] call DAC_fConfigEvents) select 3) select 1)};
					_sum = [_wparray,0] call DAC_fSumWaypoints;
					if(count _heloarray == 1) then
					{
						_zonepos = call compile (_heloarray select 0);
					}
					else
					{
						_zonepos = call compile (_heloarray select (random ((count _heloarray) - 1)));
					};
					if(((getwppos[_group,3]) select 0) == 100) then
					{
						[_group, 3] setWaypointPosition [position _leader, 0];
						if(((((_zskill select 7) select 5) select 0) + (((_zskill select 7) select 5) select 1)) == 0) then
						{
							_firstwait = 1;
						}
						else
						{
							_firstwait = ((((_zskill select 7) select 5) select 0) + random (((_zskill select 7) select 5) select 1));
						};
					}
					else
					{
						_firstwait = 1;
					};
					_patrolon = 0;_unitcombat = _zskill select 1;_unitbehav = _zskill select 2;_unitspeed = _zskill select 3;
					_unitheight = _zskill select 6;_maxweather = ((_zskill select 6) select 2);_hport = ((_zskill select 6) select 3);
					_unitwait1 = "(((_zskill select 7) select (_groupid - 1)) select 2)";
					_unitwait2 = "((((_zskill select 7) select (_groupid - 1)) select 0) + (random (((_zskill select 7) select (_groupid - 1)) select 1)))";
					{call compile format["if(_group in %1) then {%1 = %1 - [_group]}",_x]}foreach _DAC_Arrays;
					if(_hport == 1) then {_helip = "HeliHEmpty" createvehicle [0,0,0]};
					{_x leaveVehicle _helo} foreach crew _helo;_helo setfuel 1;
					[_group, 3] setWaypointPosition [[(position _helo Select 0) + (Sin (direction _helo) * 10),(position _helo Select 1) + (Cos (direction _helo) * 10),0], 0];
					_driver move [(position _helo Select 0) + (Sin (direction _helo) * 10),(position _helo Select 1) + (Cos (direction _helo) * 10),0];
					{_x setunitpos "middle"} foreach units _group;_run = 2;
				};
		case 2:	{
					//-----------------------------
					//#firstwait
					//-----------------------------
					sleep _firstwait;
					_go = 1;_wait = (time + (call compile _unitwait2));
					while {_go > 0} do
					{
						sleep (1 + (random 1));
						if(((getMarkerSize (_marker select 0)) select 0) == 4) then {deletevehicle _nextpos;_run = 0;_go = 0};
						if((({alive _x} count units _group) == 0) && (_go > 0)) then {_run = 15;_go = 0};
						if((_vehcargo == 1) && (_go > 0)) then
						{
							if(((getwppos[_group, 2]) select 0) < 25) then
							{
								while {_go > 0} do
								{
									sleep (1 + (random 1));
									if(((getMarkerSize (_marker select 0)) select 0) == 4) then {deletevehicle _nextpos;_run = 0;_go = 0};
									if((({alive _x} count units _group) == 0) && (_go > 0)) then {_run = 15;_go = 0};
									if(((count (crew _helo)) > 0) && (_go > 0)) then {_go = 0};
								};
							};
						}
						else
						{
							if(time > _wait) then {_go = 0};
							if(_sum != [_wparray,0] call DAC_fSumWaypoints) then {_sum = [_wparray,0] call DAC_fSumWaypoints;[37,_groupid,_group,"",player distance _leader] spawn DAC_fShowRadio;_go = 0};
						};
					};
					if(_run == 2) then
					{
						if(count _heloarray == 1) then {_zonepos = call compile (_heloarray select 0)} else {_zonepos = call compile (_heloarray select (random ((count _heloarray) - 1)))};
						_driver move [(position _driver Select 0) + (Sin (180) * 500),(position _driver Select 1) + (Cos (180) * 500),0];_driver assignasdriver _helo;
						[_group, 3] setWaypointPosition [position _helo, 1];
						if(!(isNull _gunner)) then {_gunner assignasgunner _helo};{[_x] ordergetin true} foreach _hcrew;_run = 3;
					};
				};
		case 3:	{
					//-----------------------------
					//#RandomZone
					//-----------------------------
					if(_inflight == 0) then
					{
						_inflight = 1;
						if(count _heloarray == 1) then
						{
							_zonepos = call compile (_heloarray select 0);
						}
						else
						{
							_zonepos = call compile (_heloarray select (random ((count _heloarray) - 1)));
						};
					};
					_go = 1;if(_hport == 1) then {_helip setpos [0,0,0]};
					_homepos = call compile (_wparray select 0);[_group, 3] setWaypointPosition [_homepos, 1];
					while {_go > 0} do
					{
						_patrolX = _zonepos select 1;_patrolY = _zonepos select 2;_maxwps = _zonepos select 3;
						_ActivZoneX = (((_zonepos select 0) select 0) - _patrolX);_ActivZoneY = (((_zonepos select 0) select 1) - _patrolY);
						_RandomX = _ActivZoneX + random (_patrolX * 2);_RandomY = _ActivZoneY + random (_patrolY * 2);
						_NewHeight = ((_unitheight select 0) + random ((_unitheight select 1) - (_unitheight select 0)));
						_nextpos setpos [_RandomX,_RandomY,0];
						if(([((getpos vehicle _leader) select 0),((getpos vehicle _leader) select 1),0] distance _nextpos) > 50) then {_go = 0;_run = 4};
						sleep 0.01;
					};
				};
		case 4:	{
					//-----------------------------
					//#setbehaviour
					//-----------------------------
					_speedselect  = (random ((count _unitspeed) - 1));
					_combatselect = (random ((count _unitcombat) - 1));
					_behavselect  = (random ((count _unitbehav) - 1));
					{_x setcombatmode (_unitcombat select _combatselect)} foreach units _group;
					{_x setbehaviour (_unitbehav select _behavselect)} foreach units _group;
					{_x setspeedmode (_unitspeed select _speedselect)} foreach units _group;
					_go = 1;
					while {_go > 0} do
					{
						sleep (1 + (random 1));
						if(({alive _x} count units _group) == 0) then {_run = 15;_go = 0};
						if(_driver in _helo) then {_run = 5;_go = 0};
					};
					if(_vehcargo == 1) then
					{
						if(_exgroup in DAC_Cover_Groups) then
						{
							_run = 14;
						};
					};
				};
		case 5:	{
					//-----------------------------
					//#dynamicmove
					//-----------------------------
					vehicle _leader flyinheight _NewHeight;
					vehicle _leader move position _nextpos;
					[_group, 3] setWaypointPosition [position _nextpos, 1];[_group, 1] setWaypointPosition [[10,0], 0];
					_go = 1;
					while {_go > 0} do
					{
						sleep (1 + (random 1));
						_call = [_group,_leader,_marker,_helo,0] call DAC_fOtherConditions;
						if((count _call) > 0) then
						{
							_run = (_call select 0);_target = (_call select 1);_go = 0;
						}
						else
						{
							if(_vehcargo == 1) then
							{
								if(({alive _x} count units _group) > 0) then
								{
									if(_exgroup in DAC_Cover_Groups) then
									{
										_go = 0;_run = 14;
									}
									else
									{
										if(((getwppos[_exgroup, 2]) select 0) < 10) then {_go = 0;_run = 16};
									};
								};
							};
							if((_sum != [_wparray,0] call DAC_fSumWaypoints) && (_go > 0)) then {_sum = [_wparray,0] call DAC_fSumWaypoints;[37,_groupid,_group,"",player distance _leader] spawn DAC_fShowRadio;_go = 0;_run = 3};
							if((_group in DAC_Cover_Groups) && (_go > 0)) then {_go = 0;_run = 11};
							if((unitready vehicle _leader) && (_go > 0)) then {_go = 0};
						};
					};
					if(overcast > _maxweather) then {_patrolon = _maxwps};
					_patrolon = _patrolon + 1;_run = 6;
				};
		case 6:	{
					//-----------------------------
					//#waiting
					//-----------------------------
					if((count _EventList) > 0) then {call compile (_EventList select 0)};
					if(_patrolon > _maxwps) then
					{
						_run = 7;_inflight = 0;
					}
					else
					{
						_wait = time + random (call compile _unitwait1);_go = 1;
						_zskill = [((getMarkerPos (_marker select 2)) select 1)] call DAC_fConfigBehav;
						while {_go > 0} do
						{
							sleep (1 + (random 1));
							_call = [_group,_leader,_marker,_helo,0] call DAC_fOtherConditions;
							if((count _call) > 0) then
							{
								_run = (_call select 0);_target = (_call select 1);_go = 0;
							}
							else
							{
								if(_vehcargo == 1) then
								{
									if(({alive _x} count units _group) > 0) then
									{
										if(_exgroup in DAC_Cover_Groups) then
										{
											_go = 0;_run = 14;
										}
										else
										{
											if(((getwppos[_exgroup, 2]) select 0) < 10) then {_go = 0;_run = 16};
										};
									};
								};
								if((_sum != [_wparray,0] call DAC_fSumWaypoints) && (_go > 0)) then {_sum = [_wparray,0] call DAC_fSumWaypoints;[37,_groupid,_group,"",player distance _leader] spawn DAC_fShowRadio;_go = 0;_run = 3};
								if((_group in DAC_Cover_Groups) && (_go > 0)) then {_go = 0;_run = 11};
								if((time > _wait) && (_go > 0)) then
								{
									if(_oldskill != ((getMarkerPos (_marker select 2)) select 1)) then
									{
										_zskill = [((getMarkerPos (_marker select 2)) select 1)] call DAC_fConfigBehav;_oldskill = ((getMarkerPos (_marker select 2)) select 1);
										_unitcombat = _zskill select 1;_unitbehav = _zskill select 2;_unitspeed = _zskill select 3;
										_unitheight = _zskill select 6;_maxweather = ((_zskill select 6) select 2);_hport = ((_zskill select 6) select 3);
										_unitwait1 = "(((_zskill select 7) select (_groupid - 1)) select 2)";
										_unitwait2 = "((((_zskill select 7) select (_groupid - 1)) select 0) + (random (((_zskill select 7) select (_groupid - 1)) select 1)))";
										_speedselect  = (random ((count _unitspeed) - 1));_combatselect = (random ((count _unitcombat) - 1));_behavselect  = (random ((count _unitbehav) - 1));
										{_x setcombatmode (_unitcombat select _combatselect)} foreach units _group;
										{_x setbehaviour (_unitbehav select _behavselect)} foreach units _group;
										{_x setspeedmode (_unitspeed select _speedselect)} foreach units _group;
									};
									_go = 0;_run = 3;_inflight = 1;
								};
							};
						};
					};
				};
		case 7:	{
					//-----------------------------
					//#landing
					//-----------------------------
					_patrolon = 0;
					if(_landmodus < 2) then
					{
						_homepos = call compile (_wparray select 0);_nextpos setpos _homepos;
						_helo flyinheight 50;_helo move getpos _nextpos;_helo setspeedmode "limited";
						[_group, 3] setWaypointPosition [_homepos, 1];[_group, 1] setWaypointPosition [[60,0], 0];_go = 1;
						while {_go > 0} do
						{
							sleep (1 + (random 1));
							_call = [_group,_leader,_marker,_helo,0] call DAC_fOtherConditions;
							_temppos = [(position _helo select 0),(position _helo select 1),0];
							if((count _call) > 0) then
							{
								_run = (_call select 0);_target = (_call select 1);_go = 0;
							}
							else
							{
								if(_vehcargo == 1) then
								{
									if(({alive _x} count units _group) > 0) then
									{
										if(_exgroup in DAC_Cover_Groups) then
										{
											_go = 0;_run = 14;
										}
										else
										{
											if(((getwppos[_exgroup, 2]) select 0) < 10) then {_go = 0;_run = 16};
										};
									};
								};
								if((_sum != [_wparray,0] call DAC_fSumWaypoints) && (_go > 0)) then {_sum = [_wparray,0] call DAC_fSumWaypoints;[37,_groupid,_group,"",player distance _leader] spawn DAC_fShowRadio;_go = 0;_run = 3};
								if((unitready _helo) && ((_temppos distance _nextpos) < 100) && (_go > 0)) then {_go = 0};
								if((_group in DAC_Cover_Groups) && (_go > 0)) then {_go = 0;_run = 11};
							};
						};
						if(_run == 7) then
						{
							_nextpos setpos [0,0,0];
							if(_hport == 1) then {_helip setpos _homepos};
						};
					}
					else
					{
						_nextpos setpos [0,0,0];_landmodus = 0;
						if(_hport == 1) then {_helip setpos (position ((units _exgroup) select 0))};
					};
					if(_run == 7) then
					{
						sleep 3;
						_helo land "land";_go = 1;
						while {_go > 0} do
						{
							sleep (1 + (random 1));
							_call = [_group,_leader,_marker,_helo,0] call DAC_fOtherConditions;
							if((count _call) > 0) then
							{
								_run = (_call select 0);_target = (_call select 1);_go = 0;
							}
							else
							{
								if(_vehcargo == 1) then
								{
									if(({alive _x} count units _group) > 0) then
									{
										if(_exgroup in DAC_Cover_Groups) then
										{
											_go = 0;_run = 14;
										}
										else
										{
											if(((getwppos[_exgroup, 2]) select 0) < 10) then {_go = 0;_run = 16};
										};
									};
								};
								if((getpos _helo select 2 < 2) && (_go > 0)) then {_go = 0};
							};
						};
					};
					if(_run == 7) then
					{
						sleep 3;
						[_group, 3] setWaypointPosition [position _helo, 1];[_group, 1] setWaypointPosition [[60,0], 0];
						if(_landmodus == 1) then
						{
							_run = 8;
						}
						else
						{
							if(_vehcargo != 1) then
							{
								_run = 9;
							}
							else
							{
								{_x leaveVehicle _helo} foreach [_group,_exgroup];
								[_group, 2] setWaypointPosition [[30,0], 0];
								_driver move [(position _helo Select 0) + (Sin (direction _helo) * 10),(position _helo Select 1) + (Cos (direction _helo) * 10),0];
								{_x setunitpos "middle"} foreach units _group;_go = 1;
								while {_go > 0} do
								{
									sleep (1 + (random 1));
									_call = [_group,_leader,_marker,_helo,1] call DAC_fOtherConditions;
									if((count _call) > 0) then
									{
										_run = (_call select 0);_target = (_call select 1);_go = 0;
									}
									else
									{
										if(((getwppos[_group, 2]) select 0) < 25) then {_go = 0};
									};
								};
								_driver move [(position _driver Select 0) + (Sin (180) * 500),(position _driver Select 1) + (Cos (180) * 500),0];_driver assignasdriver _helo;
								if(!(isNull _gunner)) then {_gunner assignasgunner _helo};{[_x] ordergetin true} foreach _hcrew;_go = 1;
								sleep 1;
								while {_go > 0} do
								{
									sleep (1 + (random 1));
									_call = [_group,_leader,_marker,_helo,1] call DAC_fOtherConditions;
									if((count _call) > 0) then
									{
										_run = (_call select 0);_target = (_call select 1);_go = 0;
									}
									else
									{
										if(_driver in _helo) then {_run = 3;_go = 0};
									};
								};
							};
						};
					};
				};
		case 8:	{
					//-----------------------------
					//#waitforgroup
					//-----------------------------
					{_x leaveVehicle _helo} foreach [_group];_helo setfuel 1;
					_driver move [(position _helo Select 0) + (Sin (direction _helo) * 10),(position _helo Select 1) + (Cos (direction _helo) * 10),0];
					{_x setunitpos "middle"} foreach units _group;_go = 1;
					while {_go > 0} do
					{
						sleep (1 + (random 1));
						if(((getMarkerSize (_marker select 0)) select 0) == 4) then {deletevehicle _nextpos;_run = 0;_go = 0};
						if((({alive _x} count units _group) == 0) && (_go > 0)) then {_run = 15;_go = 0};
						if((((getdammage _helo) > 0.7) || (!(canmove _helo))) && (_go > 0)) then {_run = 15;_go = 0};
						if(_group in DAC_Hit_Groups) then {_go = 0;_run = 19};
						if(_go > 0) then
						{
							if(({alive _x} count units _exgroup) == 0) then
							{
								_vehcargo = 0;_run = 2;_go = 0;
							}
							else
							{
								if(((getwppos[_exgroup, 2]) select 0) < 10) then {_go = 0;_run = 16};
							};
						};
					};
				};
		case 9:	{
					//-----------------------------
					//#pausehelo
					//-----------------------------
					_group leaveVehicle _helo;_wait = (time + (call compile _unitwait2));_helo setfuel 1;
					_driver move [(position _helo Select 0) + (Sin (direction _helo) * 10),(position _helo Select 1) + (Cos (direction _helo) * 10),0];
					{_x setunitpos "middle"} foreach units _group;_go = 1;
					while {_go > 0} do
					{
						sleep (1 + (random 1));
						_call = [_group,_leader,_marker,_helo,1] call DAC_fOtherConditions;
						if((count _call) > 0) then
						{
							_run = (_call select 0);_target = (_call select 1);_go = 0;
						}
						else
						{
							if(_sum != [_wparray,0] call DAC_fSumWaypoints) then {_sum = [_wparray,0] call DAC_fSumWaypoints;[37,_groupid,_group,"",player distance _leader] spawn DAC_fShowRadio;_go = 0};
							if((time > _wait) && (_go > 0)) then {_go = 0};
						};
					};
					if(_run == 9) then
					{
						_driver move [(position _driver Select 0) + (Sin (180) * 500),(position _driver Select 1) + (Cos (180) * 500),0];_driver assignasdriver _helo;
						if(!(isNull _gunner)) then {_gunner assignasgunner _helo};{[_x] ordergetin true} foreach _hcrew;_go = 1;
						sleep 1;
						while {_go > 0} do
						{
							sleep (1 + (random 1));
							_call = [_group,_leader,_marker,_helo,1] call DAC_fOtherConditions;
							if((count _call) > 0) then
							{
								_run = (_call select 0);_target = (_call select 1);_go = 0;
							}
							else
							{
								if(_driver in _helo) then {_run = 3;_go = 0};
							};
						};
					};
				};
		case 10:{
					//-----------------------------
					//#groupchangemove
					//-----------------------------
					if(((getdammage _helo) > 0.7) || (!(canmove _helo))) then {_run = 15};
					if(!(_group in DAC_Radio_Groups)) then {[27,_groupid,_group,"",_target distance _leader] spawn DAC_fShowRadio};
					if(!(_driver in _helo)) then
					{
						if((count (crew _helo)) > 0) then {_group leaveVehicle _helo};
						if(_vehcargo == 1) then {_exgroup leaveVehicle _helo};
						_run = 19;
					}
					else
					{
						if(((position _driver) select 2) < 5) then
						{
							if((count (crew _helo)) > 0) then {_group leaveVehicle _helo};
							if(_vehcargo == 1) then {_exgroup leaveVehicle _helo};
							_run = 19;
						}
						else
						{
							_run = 11;_rd = random 360;_dist = (100 / ((0.1 + skill _driver) * DAC_AI_Level));_callg = [];
						};
					};
				};
		case 11:{
					//-----------------------------
					//#groupmovetoenemy
					//-----------------------------
					if(_group in DAC_Hit_Groups) then
					{
						{if((!(side _x == side leader _group)) && (((leader _group) knowsabout _x) > 0) && (alive _x))  then {_callg = _callg + [_x]}} foreach DAC_Fire_Pos;
						if((count _callg) > 0) then
						{
							if((count _callg) > 1) then
							{
								_target = _callg select (random ((count _callg) - 1));
							}
							else
							{
								_target = _callg select 0;
							};
							_nextpos setpos [(position _target Select 0) + (Sin (_rd) * _dist),(position _target Select 1) + (Cos (_rd) * _dist),0];
							_helo flyinheight 150;_helo move position _nextpos;_go = 1;
							[_group, 3] setWaypointPosition [_nextpos, 1];[_group, 1] setWaypointPosition [[30,0], 0];
							while {_go > 0} do
							{
								sleep (1 + (random 1));
								if(((getMarkerSize (_marker select 0)) select 0) == 4) then {deletevehicle _nextpos;_run = 0;_go = 0};
								if((({alive _x} count units _group) == 0) && (_go > 0)) then {_run = 15;_go = 0};
								if((((getdammage _helo) > 0.7) || (!(canmove _helo))) && (_go > 0)) then {_run = 15;_go = 0};
								if((unitready _helo) && (_go > 0)) then
								{
									if(_vehcargo == 1) then
									{
										if(({_x in _helo} count units _exgroup) == 0) then {_run = 12} else {_run = 13};
									}
									else
									{
										_run = 12
									};
									_go = 0;
								};
							};
						}
						else
						{
							_target = objNull;_run = 3;
							if(_group in DAC_Hit_Groups) then {DAC_Hit_Groups = DAC_Hit_Groups - [_group]};
							if(_group in DAC_Radio_Groups) then {DAC_Radio_Groups = DAC_Radio_Groups - [_group]};
						};
					}
					else
					{
						if(_group in DAC_Cover_Groups) then
						{
							_callg = [];_grouponfire = _group;
							{if(side (leader _x ) == side leader _group) then {_callg = _callg + [_x]}} foreach DAC_Call_Groups;
							if((count _callg) == 0) then
							{
								DAC_Cover_Groups = DAC_Cover_Groups - [_group];_run = 3;
							}
							else
							{
								_grouponfire = _callg select (random ((count _callg) - 1));
								_nextpos setpos [(position (leader _grouponfire) select 0),(position (leader _grouponfire) select 1),0];
								[21,_groupid,_group,"",(leader _grouponfire) distance _leader] spawn DAC_fShowRadio;
								[_group, 3] setWaypointPosition [_nextpos, 1];[_group, 1] setWaypointPosition [[50,0], 0];
							};
						}
						else
						{
							_go = 1;_wait = (time + 10);
							while {_go > 0} do
							{
								_nextpos setpos [(position _target Select 0) + (Sin (_rd) * _dist),(position _target Select 1) + (Cos (_rd) * _dist),0];
								if(surfaceIsWater (position _nextpos)) then
								{
									sleep 0.1;
									if(time > _wait) then {_go = 0;_run = 3};
								}
								else
								{
									_go = 0;[_group, 3] setWaypointPosition [_nextpos, 1];[_group, 1] setWaypointPosition [[30,0], 0];
								};
							};
						};
						if(_run == 11) then
						{
							_helo flyinheight 150;_helo move position _nextpos;_go = 1;
							while {_go > 0} do
							{
								sleep (1 + (random 1));
								if(((getMarkerSize (_marker select 0)) select 0) == 4) then {deletevehicle _nextpos;_run = 0;_go = 0};
								if((({alive _x} count units _group) == 0) && (_go > 0)) then {_run = 15;_go = 0};
								if((((getdammage _helo) > 0.7) || (!(canmove _helo))) && (_go > 0)) then {_run = 15;_go = 0};
								if((unitready _helo) && (_go > 0)) then
								{
									if(_vehcargo == 1) then
									{
										if(({_x in _helo} count units _exgroup) == 0) then {_run = 12} else {_run = 13};
									}
									else
									{
										_run = 12;
									};
									_go = 0;
								};
							};
						};
					};
				};
		case 12:{
					//-----------------------------
					//#cargono
					//-----------------------------
					if(_group in DAC_Cover_Groups) then
					{
						_landmodus == 0;_run = 19;
					}
					else
					{
						_go = 1;
						while {_go > 0} do
						{
							sleep (1 + (random 1));
							if(((getMarkerSize (_marker select 0)) select 0) == 4) then {deletevehicle _nextpos;_run = 0;_go = 0};
							if((({alive _x} count units _group) == 0) && (_go > 0)) then {_run = 15;_go = 0};
							if((((getdammage _helo) > 0.7) || (!(canmove _helo))) && (_go > 0)) then {_run = 15;_go = 0};
							if(_go > 0) then
							{
								if(unitready _helo) then
								{
									if(alive _target) then
									{
										if(({(((_x knowsabout _target) >= _knowsabout)  && ((_x distance _target) < DAC_Alert_Dist))} count units _group) > 0) then
										{
											_go = 0;_run = 11;
										}
										else
										{
											_go = 2;
										};
									}
									else
									{
										_go = 2;
									};
								};
								if(_go == 2) then
								{
									if(_vehcargo == 1) then
									{
										_go = 0;_run = 7;
									}
									else
									{
										[38,_groupid,_group,"",_target distance _leader] spawn DAC_fShowRadio;
										_go = 0;_run = 3;
									};
									if(_group in DAC_Hit_Groups) then {DAC_Hit_Groups = DAC_Hit_Groups - [_group]};
									if(_group in DAC_Radio_Groups) then {DAC_Radio_Groups = DAC_Radio_Groups - [_group]};
								};
							};
						};
					};
				};
		case 13:{
					//-----------------------------
					//#cargoyes
					//-----------------------------
					if(_landmodus < 2) then
					{
						_helo flyinheight 150;_helo setspeedmode "limited";
						DAC_Fire_Groups = DAC_Fire_Groups + [_exgroup];
					};
					sleep 3;
					_group reveal _target;
					_crew = units _exgroup;_go = count _crew;
					while {_go > 0} do
					{
						_go = _go - 1;
						_man = _crew select _go;
						if(alive _man) then
						{
							_man action ["EJECT",_helo];unassignvehicle _man;
							sleep 1;
						};
						if(((getMarkerSize (_marker select 0)) select 0) == 4) then {deletevehicle _nextpos;_run = 0;_go = -1};
					};
					if(_landmodus < 2) then {[[_exgroup,_marker],_target,_wparray,6,1,_zskill,[_helo,_group,_heloarray]] spawn DAC_fMoveToEnemy};
					[_group, 2] setWaypointPosition [[100,0], 0];_landmodus = 1;_helo setspeedmode "full";_helo flyinheight 50;_run = 12;
				};
		case 14:{
					//-----------------------------
					//#groupmovetofriendly
					//-----------------------------
					sleep 1;
					_nextpos setpos getwppos[_exgroup, 0];
					_helo flyinheight 150;_helo move position _nextpos;_go = 1;
					[_group, 3] setWaypointPosition [_nextpos, 1];[_group, 1] setWaypointPosition [[50,0], 0];
					while {_go > 0} do
					{
						sleep (1 + (random 1));
						if(((getMarkerSize (_marker select 0)) select 0) == 4) then {deletevehicle _nextpos;_run = 0;_go = 0};
						if((({alive _x} count units _group) == 0) && (_go > 0)) then {_run = 15;_go = 0};
						if((((getdammage _helo) > 0.7) || (!(canmove _helo))) && (_go > 0)) then {_run = 15;_go = 0};
						if(unitready _helo) then
						{
							_go = 0;
						};
					};
					_helo setspeedmode "limited";
					sleep 3;
					_crew = units _exgroup;_go = count _crew;
					while {_go > 0} do
					{
						_go = _go - 1;
						_man = _crew select _go;
						if(alive _man) then
						{
							_man action ["EJECT",_helo];unassignvehicle _man;
							sleep 1;
						};
						if(((getMarkerSize (_marker select 0)) select 0) == 4) then {deletevehicle _nextpos;_run = 0;_go = -1};
					};
					[_group, 2] setWaypointPosition [[100,0], 0];_landmodus = 1;_helo setspeedmode "full";_helo flyinheight 50;_run = 7;
				};
		case 15:{
					//-----------------------------
					//#getouthelo
					//-----------------------------
					if(({alive _x} count crew _helo) == 0) then
					{
						_run = 0;
					}
					else
					{
						if(({alive _x} count units _group) > 0) then
						{
							if(canmove _helo) then
							{
								_helo flyinheight 150;
								sleep 3;
							};
						};
						_crew = crew _helo;_go = count _crew;
						[29,_groupid,_group,"",_target distance _leader] spawn DAC_fShowRadio;
						while {_go > 0} do
						{
							_go = _go - 1;
							_man = _crew select _go;
							if(alive _man) then
							{
								_man action ["EJECT",_helo];unassignvehicle _man;_man setcombatmode "red";_man setbehaviour "aware";
							};
							if(((getMarkerSize (_marker select 0)) select 0) == 4) then {deletevehicle _nextpos;_run = 0;_go = -1};
							sleep 0.5;
						};
						_run = 18;_go = 1;
					};
				};
		case 16:{
					//-----------------------------
					//#moveBackToGroup
					//-----------------------------
					_driver move (position ((units _exgroup) select 0));_driver assignasdriver _helo;
					[_exgroup, 3] setWaypointPosition [(position _helo), 0];
					if(!(isNull _gunner)) then {_gunner assignasgunner _helo};{[_x] ordergetin true} foreach _hcrew;_go = 1;
					sleep 1;
					while {_go > 0} do
					{
						sleep (1 + (random 1));
						if(((getMarkerSize (_marker select 0)) select 0) == 4) then {deletevehicle _nextpos;_go = 0;_run = 0};
						if((({alive _x} count units _group) == 0) && (_go == 1)) then {deletevehicle _nextpos;_run = 0;_go = 0};
						if((((getdammage _helo) > 0.7) || (!(canmove _helo))) && (_go == 1)) then {_run = 15;_go = 0};
						if(unitready vehicle _leader) then
						{
							_go = 0;_landmodus = 2;_patrolon = 0;_run = 7;
						};
					};
				};
		case 17:{
					//disabled
				};
		case 18:{
					//-----------------------------
					//#joinGroup
					//-----------------------------
					_go = 1;
					[_group, 3] setWaypointPosition [(position _leader), 0];[_group, 1] setWaypointPosition [[10,0], 0];
					while {_go > 0} do
					{
						if((((getMarkerSize (_marker select 0)) select 0) == 4)
						|| ((({alive _x} count units _group) == 0))) then {deletevehicle _nextpos;_go = 0;_run = 0};
						if(_go > 0) then
						{
							_jArray = [_group] call DAC_fFindGroup;
							if(count _jArray > 0) then
							{
								[_group,(_jArray select 0),1] spawn DAC_fRemoveGroup;
								_run = 0;_go = 0;
							}
							else
							{
								sleep (1 + (random 0.5));
							};
						};
					};
				};
		case 19:{
					//-----------------------------
					//#Alert
					//-----------------------------
					sleep 1;
					_go = 1;_waittime = time + 60;
					if(!(_driver in _helo)) then
					{
						{_x setcombatmode "red";_x setbehaviour "aware";_x setunitpos "down"} foreach units _group;
						while {_go > 0} do
						{
							sleep (1 + (random 1));
							if(((getMarkerSize (_marker select 0)) select 0) == 4) then {deletevehicle _nextpos;_go = 0;_run = 0};
							if((({alive _x} count units _group) == 0) && (_go == 1)) then {deletevehicle _nextpos;_run = 0;_go = 0};
							if((((getdammage _helo) > 0.7) || (!(canmove _helo))) && (_go == 1)) then {_run = 15;_go = 0};
							if((isNull(_leader findNearestEnemy (position _leader))) && (_go == 1)) then
							{
								if(_landmodus == 0) then
								{
									if(_group in DAC_Cover_Groups) then {DAC_Cover_Groups = DAC_Cover_Groups - [_group]};
									[_group, 1] setWaypointPosition [[10,0], 0];_run = 2;_go = 0;
								}
								else
								{
									_run = 8;_go = 0;
								};
							};
						};
					}
					else
					{
						_go = 1;_helo flyinheight 50;_helo setspeedmode "limited";
						while {_go > 0} do
						{
							_rdir = random 360;_flypos = [((position _nextpos select 0) + (Sin _rdir * 200)),((position _nextpos select 1) + (Cos _rdir * 200)),0];
							[_group, 3] setWaypointPosition [_flypos, 1];
							_helo move _flypos;_go = 2;
							while {_go > 1} do
							{
								sleep (1 + (random 1));
								if(((getMarkerSize (_marker select 0)) select 0) == 4) then {deletevehicle _nextpos;_go = 0;_run = 0};
								if((({alive _x} count units _group) == 0) && (_go == 2)) then {deletevehicle _nextpos;_run = 0;_go = 0};
								if((((getdammage _helo) > 0.7) || (!(canmove _helo))) && (_go == 2)) then {_run = 15;_go = 0};
								if(((unitready _helo) || ((_helo distance _flypos) < 80)) && (_go == 2)) then
								{
									if(!(isNull([_leader,_group,_target] call DAC_fEnemyCond))) then
									{
										_target = [_leader,_group,_target] call DAC_fEnemyCond;
										_nextpos setpos (position _target);_waittime = time + 30;_target = objNull;_go = 1;
									}
									else
									{
										if(time > _waittime) then
										{
											if(_group in DAC_Cover_Groups) then {DAC_Cover_Groups = DAC_Cover_Groups - [_group]};
											[_group, 1] setWaypointPosition [[10,0], 0];_run = 2;_go = 0;
										}
										else
										{
											_go = 1;
										};
									};
								};
							};
						};
					};
				};
		case 20:{
				};
		Default{};
	};
};
if(_hport == 1) then {deletevehicle _helip};