//////////////////////////////
//    Dynamic-AI-Creator    //
//    Version 1.2 - 2007    //
//--------------------------//
//    DAC_Create_Objects    //
//--------------------------//
//    Script by Silola      //
//    silola@mapfact.net    //
//////////////////////////////

//[logic,radX,radY,countObjects,wpConfig,wpTyp,break] call DAC_fCreateObjects

//if(true) exitwith {};

private [
			"_DAC_CNr","_DAC_WP_Typ","_wpConfig","_CheckRadius1","_CheckRadius2","_checkAreaH","_checkNear","_checkObjH1",
			"_checkMaxH","_checkMinH","_checkCount","_DAC_Typ_Nr","_MTemp","_string","_TempArray","_checkObjH2",
			"_DAC_Typ_Name","_minit","_tnr","_wpi","_DumyA","_DumyB","_Null","_PosNull","_zonr","_wpnr","_chnr",
			"_hz","_DAC_Count_WP","_DAC_SelectZone","_DAC_EnemyZone","_DAC_ZoneRadiusX","_DAC_ZoneRadiusY",
			"_tempList","_ln","_wn","_checkwp","_log","_DAC_ActivZoneX","_DAC_ActivZoneY","_RandomX","_RandomY",
			"_PosMin","_PosMax","_nr","_cv","_cr","_np","_cd","_allObjects","_relObjects","_DPos","_ma","_run",
			"_go","_m1","_m2","_m3","_mm3","_m4","_mm4","_DAC_WP_Nr","_mylogic","_parax","_paray","_ocount","_DAC_Ct",
			"_diff","_oconf","_wconf","_oarray","_warray","_i","_run","_go","_ok","_nextobj","_rndobj","_newo","_objbibl"
		];
		
			_mylogic = _this select 0;_DAC_ZoneRadiusX = _this select 1;_DAC_ZoneRadiusY = _this select 2;
			_wpConfig = [];_RandomX = 0;_RandomY = 0;_DAC_Count_WP = _this select 3;_wpi = _this select 4;
			_DAC_Typ_Nr = ["S","V","T","A","C"];_MTemp = [];_string ="Null";_TempArray = [];_minit = 0;
			_run = 3;_go = 0;_DAC_WP_Nr = 0;_nextobj = objNull;_newo = "";_DAC_CNr = _this select 5;
			_DAC_Ct = _this select 6;
			
			_objbibl = 	[
							[["AAPL068","AAPL076"],0],
							[["AAPL058","AAPL059","AAPL060","AAPL062","AAPL063","AAPL055","AAPL004"],0],
							[["AAHO050","AAHO067","AAHO040"],0]
						];
			_rndobj = ((_objbibl select _DAC_CNr) select 0);_DAC_WP_Typ = ((_objbibl select _DAC_CNr) select 1);

sleep _DAC_Ct;

while {_run > 0} do
{
	switch (_run) do
	{
		case 3:	{
					_DumyA = "logic" createvehiclelocal [0,0,0];
					_DumyB = "logic" createvehiclelocal [0,0,0];
					_Null = "EmptyDetector" createvehiclelocal [0,0,0];
					_PosNull = 0;_zonr = 0;_wpnr = 0;_chnr = 0;_hz = 0;
					_wpConfig = [_DAC_WP_Typ,_wpi] call DAC_fConfigWP;
					if(count _wpConfig == 0) then
					{
						player sidechat "DAC_Create_Object: bad wpconfig";_run = 0;
					}
					else
					{
						_CheckRadius1 = ((_wpConfig select 0) select 0);_CheckRadius2 = ((_wpConfig select 0) select 1);
						_checkAreaH = _wpConfig select 1;_checkNear = _wpConfig select 2;
						_checkObjH1 = ((_wpConfig select 3) select 0);_checkObjH2 = ((_wpConfig select 3) select 1);
						_checkMaxH = _wpConfig select 4;_checkMinH = _wpConfig select 5;_checkCount = _wpConfig select 6;
						_checkResol = ((_wpConfig select 0) select 2);
						_DAC_ActivZoneX  = ((getpos _mylogic select 0) - _DAC_ZoneRadiusX);
						_DAC_ActivZoneY  = ((getpos _mylogic select 1) - _DAC_ZoneRadiusY);
						_run = 7;
					};
				};
		case 7:	{
					_go = 1;
					while {_go > 0} do
					{
						if(_chnr > _checkCount) then
						{
							_run = 11;_go = 0;
						}
						else
						{
							_RandomX = _DAC_ActivZoneX + random (_DAC_ZoneRadiusX * 2);
							_RandomY = _DAC_ActivZoneY + random (_DAC_ZoneRadiusY * 2);
							if(_checkMinH >= 0) then
							{
								if(surfaceIsWater [_RandomX, _RandomY]) then
								{
									_chnr = _chnr + 1;
								}
								else
								{
									_Null setpos [_RandomX,_RandomY,0];_DumyA setpos [_RandomX,_RandomY,0];
									if((getPosASL _Null select 2 > _checkminh) && (getPosASL _Null select 2 < _checkmaxh)) then
									{
										_run = 8;_go = 0;
									}
									else
									{
										_chnr = _chnr + 1;
									};
								};
							}
							else
							{
								if(!(surfaceIsWater [_RandomX, _RandomY])) then
								{
									_chnr = _chnr + 1;
								}
								else
								{
									_Null setpos [_RandomX,_RandomY,0];_DumyA setpos [_RandomX,_RandomY,0];
									if((getPosASL _Null select 2 > _checkminh) && (getPosASL _Null select 2 < _checkmaxh)) then
									{
										_run = 8;_go = 0;
									}
									else
									{
										_chnr = _chnr + 1;
									};
								};
							};
						};
					};
				};
		case 8:	{
					_PosMin = (getPosASL _Null select 2);_PosMax = _PosMin;_nr = 0;_cv = 0;
					_DumyA setpos [_RandomX,_RandomY,0];_DumyA setdir 0;_cr = _CheckRadius2;_go = 1;
					while {_go > 0} do
					{
						if(_nr > 360) then
						{
							_go = 0;_run = 9;
						}
						else
						{
							if(_cv == 0) then {_cv = 1;_cr = _CheckRadius2} else {_cv = 0;_cr = (_CheckRadius2 / 2)};
							_np = 	[
										((GetPos _DumyA Select 0) + (Sin ((getdir _DumyA) + _nr) * _cr)),
										((GetPos _DumyA Select 1) + (Cos ((getdir _DumyA) + _nr) * _cr)),0
									];
							_Null setpos _np;
							if(_checkMinH >= 0) then
							{
								if(getPosASL _Null select 2 > _PosMax) then {_PosMax = (getPosASL _Null select 2)} else {if(getPosASL _Null select 2 < _PosMin) then {_PosMin = (getPosASL _Null select 2)}};
							}
							else
							{
								if(!(surfaceIsWater (position _Null))) then {_PosMax = (_checkAreaH * 10);_nr = 360};
							};
							_nr = _nr + 36;
						};
					};
				};
		case 9:	{
					if((_PosMax - _PosMin) > _checkAreaH) then
					{
						_chnr = _chnr + 1;_run = 7;
					}
					else
					{
						if(_CheckRadius1 == 0) then
						{
							_run = 10;
						}
						else
						{
							_allObjects = nearestObjects [[_RandomX,_RandomY], [], _CheckRadius1];_relObjects = [];
							{
								if(((format["%1",typeOf _x]) != "LOGIC")
								&& ((format["%1",typeOf _x]) != "EmptyDetector")
								&& ((speed _x == 0) || (canmove _x))) then
								{
									_relObjects = _relObjects + [_x];
								};
							} 	foreach _allObjects;
							if(count _relObjects > 0) then
							{
								_chnr = _chnr + 1;_run = 7;
							}
							else
							{
								_run = 10;
							};
						};
					};
				};
		case 10:{
					_allObjects = nearestObjects [[_RandomX,_RandomY], [], _CheckRadius2];_relObjects = [];
					{
						if(((format["%1",typeOf _x]) != "LOGIC")
						&& ((format["%1",typeOf _x]) != "EmptyDetector")
						&& ((speed _x == 0) || (canmove _x))) then
						{
							_relObjects = _relObjects + [_x];
						};
					} 	foreach _allObjects;
					if(({(((((boundingBox _x select 1) select 2) > _checkObjH2) && ((_x distance _DumyA) < _CheckRadius2)))} count _relObjects) > 0) then
					{
						_chnr = _chnr + 1;_run = 7;
					}
					else
					{
						if(_checkNear > 0) then
						{
							_cd = 0;
							while {_cd < count _TempArray} do
							{
								sleep 0.1;
								_DPos = _TempArray select _cd;
								if(count _DPos > 2) then
								{
									_cd = _cd + 1;
								}
								else
								{
									_DumyB setpos [(_DPos select 0),(_DPos select 1),0];
									if((_DumyB distance _DumyA) < _checkNear) then
									{
										_cd = ((count _TempArray) + 1);
										_chnr = _chnr + 1;_run = 7;
									}
									else
									{
										_cd = _cd + 1;
									};
								};
							};
						};
						if(_run != 7) then
						{
							sleep DAC_WP_Speed;
							_newo = _rndobj select (random ((count _rndobj) - 1));
							_nextobj = _newo createvehicle [_RandomX,_RandomY];_nextobj setdir (random 360);
							_nextobj setpos [_RandomX,_RandomY,(position _nextobject select 2) - (random 0.5)];_nextobj setVectorUp [0,0,0.1];
							_TempArray = _TempArray + [_nextobj];
							_wpnr = _wpnr + 1;_chnr = 0;_minit = 0;
							if(DAC_Marker > 0) then
							{
								if(((DAC_Marker_Val select 1) > 0) && (_DAC_Count_WP > 0)) then
								{
									_m = format["m%1%2%3",_zonr,_wpnr,_DAC_WP_Typ];
									_ma = createmarker [_m, position _nextobj];
									_ma setMarkerShape "RECTANGLE";
									_ma setMarkerSizelocal [((boundingBox _nextobj select 1) select 0),((boundingBox _nextobj select 1) select 1)];
									_ma setMarkerDirlocal direction _nextobj;_ma setMarkerColor "ColorGreen";
									if((DAC_Marker_Val select 1) == 1) then {_MTemp = _MTemp + [_ma]};
								};
							};
							if(_wpnr >= _DAC_Count_WP) then
							{
								_run = 12;
							}
							else
							{
								_run = 7;
							};
						};
					};
				};
		case 11:{
					player sidechat "Error DAC_Create_Objects: Cannot create all objects (bad positions)";
					sleep 1;
					{deletevehicle _x} foreach [_DumyA,_DumyB,_Null];
					_run = 0;
				};
		case 12:{
					player sidechat format["DAC creates %1 objects",count _TempArray];
					_run = 0;
				};
		case 13:{
					sleep 0.1;
					{deletevehicle _x} foreach [_DumyA,_DumyB,_Null];
					if(count _MTemp > 0) then {[_MTemp]execVM "DAC\Marker\DAC_DeleteMarker.sqf"};
					_run = 0;
				};
		Default	{};
	};
};