//////////////////////////////
//    Dynamic-AI-Creator    //
//    Version 2.0 - 2007    //
//--------------------------//
//    DAC_Insert_Group      //
//--------------------------//
//    Script by Silola      //
//    silola@mapfact.net    //
//////////////////////////////

if(DAC_Code > 1) exitwith {};

private [
			"_group","_zones","_count","_side","_behav","_options","_wparray","_vehA","_vehvalue",
			"_wptemp","_iw","_id","_dt","_entry","_newwp","_run","_go","_gtyp","_delval0","_delval1",
			"_typArray","_wpPool","_zone","_c","_a","_marker","_wpstr","_eventid"
		];

_group = _this select 0;_gtyp = _this select 1;_zones = _this select 2;_options = _this select 6;
_count = _this select 3;_side = _this select 4;_behav = _this select 5;_eventid = _this select 7;
_wparray = [];_wptemp = [];_iw = 0;_id = 0;_dt = 4;_run = 0;_go = true;_newwp = [0,0];_marker = [];
_typArray = ["S","V","T"];_wpPool = format["DAC_WP_Pool_%1",(_typArray select (_gtyp - 1))];_wpstr = "";
_delval0 = DAC_Delete_Value select 0;_delval1 = DAC_Delete_Value select 1;

if((_options select 1) == 0) then {_dt = 4};

waituntil {((getdir DAC_StartDummy) > 170)};

if(({format["%1",isnull _x] == "BOOL"} count _zones) > 0) then
{
	player sidechat "Error: DAC_Insert_Group - No valid zone";
	if(time > 0) exitwith {};
}
else
{
	sleep (0.1 + (random 1));
	_zone = _zones select 0;_c = 0;_a = "";
	while {_c < count DAC_Zones} do
	{
		_a = DAC_Zones select _c;
		if((call compile (_a select 0)) == _zone) then
		{
			_marker = (_a select 9);
			_c = ((count DAC_Zones) + 1);
		}
		else
		{
			_c = _c + 1;
		};
	};

	while{_run == 0} do
	{
		if(_iw >= count (call compile _wpPool)) then
		{
			_run = 1;
		}
		else
		{
			_entry = (call compile _wpPool) select _iw;
			if(count _entry == 2) then
			{
				_iw = _iw + 1;
			}
			else
			{
				if(!((_entry select 0) in _zones)) then
				{
					_iw = _iw + 1;
				}
				else
				{
					_iw = _iw + 1;
					while {_go} do
					{
						if(_iw >= count (call compile _wpPool)) then
						{
							_go = false;_run = 1;
						}
						else
						{
							if(count ((call compile _wpPool) select _iw) > 2) then
							{
								_go = false;
							}
							else
							{
								_wpstr = format["%1 select %2",_wpPool,_iw];
								_wptemp = _wptemp + [_wpstr];
								_iw = _iw + 1;
							};
						};
					};
				};
			};
		};
	};

	sleep 0.1;
	_run = 0;_go = true;
	while {_run == 0} do
	{
		if(count _wparray <= _count) then
		{
			_wparray = _wptemp;
			_run = 1;
		}
		else
		{
			while {_go} do
			{
				_newwp = _wptemp select (random ((count _wptemp) - 1));
				sleep 0.01;
				{if((format["%1",_newwp]) == (format["%1",_x])) then {_id = _id + 1}} foreach _wparray;
				if(_id == 0) then {_wparray = _wparray + [_newwp];_go = false} else {_id = 0};
			};
		};
	};
	sleep 0.1;
	_run = 0;
	_vehA = [];_vehvalue = [];
	{
		if((!(_x == vehicle _x)) && (!(vehicle _x in _vehA))) then
		{
			_vehA = _vehA + [vehicle _x];
			DAC_VehicleInUse = DAC_VehicleInUse + [vehicle _x];
			[(vehicle _x),_delval0,_delval1,2,(_marker select 0),_group] spawn DAC_fDeleteUnit;
		};
	} 	foreach units _group;
	if(count _wparray == 0) then
	{
		player sidechat format["Error : DAC_Insert_Group - No waypoints available for group %1",_group];
	}
	else
	{
		if((count waypoints _group) > 0) then
		{
			player sidechat format["Error : DAC_Insert_Group - group %1 has waypoints",_group];
		}
		else
		{
			_group addWaypoint [position (leader _group), 0];_group addWaypoint [position (leader _group), 0];_group addWaypoint [[10,0], 0];_group addWaypoint [[100,0], 0];
			while {_run == 0} do
			{
				if(!(_group in DAC_All_Groups)) then {DAC_All_Groups = DAC_All_Groups + [_group]};
				if(_side == 0) then {{DAC_East_Units = DAC_East_Units + [_x]} foreach units _group};
				if(_side == 1) then {{DAC_West_Units = DAC_West_Units + [_x]} foreach units _group};
				if(_side == 2) then
				{
					if(DAC_Res_Side == 0) then
					{
						{DAC_East_Units = DAC_East_Units + [_x]} foreach units _group;
					}
					else
					{
						{DAC_West_Units = DAC_West_Units + [_x]} foreach units _group;
					};
				};
				switch (_gtyp) do
				{
					case 1:	{
								[[_group,_marker,0],_wparray,1,10,0] spawn DAC_fMoveToWaypoint;
								if((_options select 0) == 1) then {[_group,_side,1,_marker,0] spawn DAC_fReduceGroup};
							};
					case 2:	{
								[[_group,_marker,0],_wparray,2,25,0] spawn DAC_fMoveWithVH;
								//if((_options select 0) == 1) then {[_group,_side,2,_marker,0] spawn DAC_fReduceGroup};
							};
					case 3:	{
								[[_group,_marker,0],_wparray,3,25,0] spawn DAC_fMoveToWaypoint;
							};
					Default	{};
				};
				if((_options select 2) == 0) then {DAC_No_Support = DAC_No_Support + [_group]};
				[_group,_dt,0,_side,[],(_marker select 0)] spawn DAC_fWaitingForEnd;
				[_group,_side] spawn DAC_fRouteMarker;
				_run = 1;
			};
			if((DAC_Com_Values select 0) > 0) then {player groupChat format["%1 was inserted into DAC",_group]};
		};
	};
};